Loading...
Searching...
No Matches
casacore::ArrayBaseAccessor< T > Class Template Reference
casa package (libcasa_casa) » Arrays_module » Arrays_module_internal_classes

Axis independent base for the ArrayAccessor classes. More...

`#include <ArrayAccessor.h>`

## Public Member Functions

void | operator+= (const size_t ix)
| Iterator-like operations.
void | operator-= (const size_t ix)
void | operator++ ()
void | operator++ (int)
void | operator-- ()
void | operator-- (int)
const T & | operator* () const
| Dereferencing.
T & | operator* ()
T * | data ()
const Array< T > & | baseArray ()
size_t | step ()
const T & | operator[] (const int ix) const
| Index along current axis.
T & | operator[] (const int ix)
const T * | end ()
| End of index on line.
const T * | end (const int n)
const T * | begin ()
| Start of index on line.
const T * | begin (const int n)
const T * | rend ()
| End when reverse indexing.
const T * | rend (const int n)
const T * | rbegin ()
| Begin when reverse indexing.
const T * | rbegin (const int n)

## Protected Member Functions

| ArrayBaseAccessor ()
| Default constructor (for use in e.g.
| ArrayBaseAccessor (const Array< T > &arr)
| Construct from an Array.
| ArrayBaseAccessor (const Array< T > &arr, const size_t ax)
| ArrayBaseAccessor (const ArrayBaseAccessor< T > &other)
| Copy constructor (copy semantics).
| ArrayBaseAccessor (const ArrayBaseAccessor< T > &other, const size_t ax)
| ~ArrayBaseAccessor ()
| Destructor.
ArrayBaseAccessor & | operator= (const ArrayBaseAccessor< T > &other)
| Assignment (copy semantics).
void | init (const Array< T > &arr)
| (Re-)initialize from Array
void | init (const Array< T > &arr, const size_t ax)
void | init (const size_t ax)

## Protected Attributes

const Array< T > * | arrayPtr_p
| The pointer to belonging array.
size_t | axis_p
| Current run-time axis.
T * | ptr_p
| Current access pointer.
int | step_p
| The increment to go from one point along an axis, to the next.
const T * | begin_p
| The start element of array.
const T * | end_p
| The one element beyond last on line.

## Detailed Description

template<class T>
class casacore::ArrayBaseAccessor< T >

Axis independent base for the ArrayAccessor classes.

### Intended use:

Internal

### Synopsis

The ArrayBaseAccessor class implements the axis independent parts of the ArrayAccessor class. It can only be used from the ArrayAccessor class.

Definition at line 60 of file ArrayAccessor.h.

## Constructor & Destructor Documentation

## ArrayBaseAccessor() [1/5]

template<class T>

casacore::ArrayBaseAccessor< T >::ArrayBaseAccessor | ( |  | ) |

inline protected

Default constructor (for use in e.g.

containers)

Definition at line 65 of file ArrayAccessor.h.

References arrayPtr_p, axis_p, begin_p, end_p, ptr_p, and step_p.

Referenced by casacore::ArrayAccessor< T, Axis< U > >::ArrayAccessor(), casacore::ArrayAccessor< T, Axis< U > >::ArrayAccessor(), casacore::ArrayAccessor< T, Axis< U > >::ArrayAccessor(), casacore::ArrayAccessor< T, Axis< U > >::ArrayAccessor(), casacore::ArrayAccessor< T, Axis< U > >::ArrayAccessor(), casacore::ArrayAccessor< T, AxisN >::ArrayAccessor(), casacore::ArrayAccessor< T, AxisN >::ArrayAccessor(), casacore::ArrayAccessor< T, AxisN >::ArrayAccessor(), casacore::ArrayAccessor< T, AxisN >::ArrayAccessor(), casacore::ArrayAccessor< T, AxisN >::ArrayAccessor(), ArrayBaseAccessor(), ArrayBaseAccessor(), and operator=().

## ArrayBaseAccessor() [2/5]

template<class T>

casacore::ArrayBaseAccessor< T >::ArrayBaseAccessor | ( | const Array< T > & | arr | ) |

inline explicit protected

Construct from an Array.

Definition at line 69 of file ArrayAccessor.h.

References arrayPtr_p, axis_p, begin_p, data(), end_p, ptr_p, and step_p.

## ArrayBaseAccessor() [3/5]

template<class T>

casacore::ArrayBaseAccessor< T >::ArrayBaseAccessor | ( | const Array< T > & | arr,
|  | const size_t | ax )

inline protected

Definition at line 72 of file ArrayAccessor.h.

References arrayPtr_p, axis_p, begin_p, data(), end_p, ptr_p, and step_p.

## ArrayBaseAccessor() [4/5]

template<class T>

casacore::ArrayBaseAccessor< T >::ArrayBaseAccessor | ( | const ArrayBaseAccessor< T > & | other | ) |

inline protected

Copy constructor (copy semantics).

Definition at line 78 of file ArrayAccessor.h.

References ArrayBaseAccessor(), arrayPtr_p, axis_p, begin_p, end_p, ptr_p, and step_p.

## ArrayBaseAccessor() [5/5]

template<class T>

casacore::ArrayBaseAccessor< T >::ArrayBaseAccessor | ( | const ArrayBaseAccessor< T > & | other,
|  | const size_t | ax )

inline protected

Definition at line 81 of file ArrayAccessor.h.

References ArrayBaseAccessor(), arrayPtr_p, axis_p, begin_p, end_p, ptr_p, and step_p.

## ~ArrayBaseAccessor()

template<class T>

casacore::ArrayBaseAccessor< T >::~ArrayBaseAccessor | ( |  | ) |

inline protected

Destructor.

Definition at line 88 of file ArrayAccessor.h.

## Member Function Documentation

## baseArray()

template<class T>

const Array< T > & casacore::ArrayBaseAccessor< T >::baseArray | ( |  | ) |

inline

Definition at line 122 of file ArrayAccessor.h.

References arrayPtr_p.

## begin() [1/2]

template<class T>

const T * casacore::ArrayBaseAccessor< T >::begin | ( |  | ) |

inline

Start of index on line.

Definition at line 140 of file ArrayAccessor.h.

References begin_p.

## begin() [2/2]

template<class T>

const T * casacore::ArrayBaseAccessor< T >::begin | ( | const int | n | ) |

inline

Definition at line 141 of file ArrayAccessor.h.

References begin_p, and step_p.

## data()

template<class T>

T * casacore::ArrayBaseAccessor< T >::data | ( |  | ) |

inline

Definition at line 121 of file ArrayAccessor.h.

References ptr_p.

Referenced by ArrayBaseAccessor(), and ArrayBaseAccessor().

## end() [1/2]

template<class T>

const T * casacore::ArrayBaseAccessor< T >::end | ( |  | ) |

inline

End of index on line.

Definition at line 134 of file ArrayAccessor.h.

References end_p.

## end() [2/2]

template<class T>

const T * casacore::ArrayBaseAccessor< T >::end | ( | const int | n | ) |

inline

Definition at line 135 of file ArrayAccessor.h.

References end_p, and step_p.

## init() [1/3]

template<class T>

void casacore::ArrayBaseAccessor< T >::init | ( | const Array< T > & | arr | ) |

inline protected

(Re-)initialize from Array

Definition at line 98 of file ArrayAccessor.h.

References arrayPtr_p, and ptr_p.

Referenced by casacore::ArrayAccessor< T, Axis< U > >::init(), casacore::ArrayAccessor< T, AxisN >::init(), and casacore::ArrayAccessor< T, AxisN >::init().

## init() [2/3]

template<class T>

void casacore::ArrayBaseAccessor< T >::init | ( | const Array< T > & | arr,
|  | const size_t | ax )

inline protected

Definition at line 100 of file ArrayAccessor.h.

References arrayPtr_p, axis_p, and ptr_p.

## init() [3/3]

template<class T>

void casacore::ArrayBaseAccessor< T >::init | ( | const size_t | ax | ) |

inline protected

Definition at line 102 of file ArrayAccessor.h.

References arrayPtr_p, axis_p, and ptr_p.

## operator*() [1/2]

template<class T>

T & casacore::ArrayBaseAccessor< T >::operator* | ( |  | ) |

inline

Definition at line 120 of file ArrayAccessor.h.

References ptr_p.

## operator*() [2/2]

template<class T>

const T & casacore::ArrayBaseAccessor< T >::operator* | ( |  | ) | const

inline

Dereferencing.

Definition at line 119 of file ArrayAccessor.h.

References ptr_p.

## operator++() [1/2]

template<class T>

void casacore::ArrayBaseAccessor< T >::operator++ | ( |  | ) |

inline

Definition at line 111 of file ArrayAccessor.h.

References ptr_p, and step_p.

## operator++() [2/2]

template<class T>

void casacore::ArrayBaseAccessor< T >::operator++ | ( | int |  | ) |

inline

Definition at line 112 of file ArrayAccessor.h.

References ptr_p, and step_p.

## operator+=()

template<class T>

void casacore::ArrayBaseAccessor< T >::operator+= | ( | const size_t | ix | ) |

inline

Iterator-like operations.

Definition at line 109 of file ArrayAccessor.h.

References ptr_p, and step_p.

## operator--() [1/2]

template<class T>

void casacore::ArrayBaseAccessor< T >::operator-- | ( |  | ) |

inline

Definition at line 113 of file ArrayAccessor.h.

References ptr_p, and step_p.

## operator--() [2/2]

template<class T>

void casacore::ArrayBaseAccessor< T >::operator-- | ( | int |  | ) |

inline

Definition at line 114 of file ArrayAccessor.h.

References ptr_p, and step_p.

## operator-=()

template<class T>

void casacore::ArrayBaseAccessor< T >::operator-= | ( | const size_t | ix | ) |

inline

Definition at line 110 of file ArrayAccessor.h.

References ptr_p, and step_p.

## operator=()

template<class T>

ArrayBaseAccessor & casacore::ArrayBaseAccessor< T >::operator= | ( | const ArrayBaseAccessor< T > & | other | ) |

inline protected

Assignment (copy semantics).

Definition at line 92 of file ArrayAccessor.h.

References ArrayBaseAccessor(), arrayPtr_p, and ptr_p.

Referenced by casacore::ArrayAccessor< T, Axis< U > >::operator=(), casacore::ArrayAccessor< T, Axis< U > >::operator=(), casacore::ArrayAccessor< T, Axis< U > >::operator=(), casacore::ArrayAccessor< T, AxisN >::operator=(), and casacore::ArrayAccessor< T, AxisN >::operator=().

## operator[]() [1/2]

template<class T>

T & casacore::ArrayBaseAccessor< T >::operator[] | ( | const int | ix | ) |

inline

Definition at line 129 of file ArrayAccessor.h.

References ptr_p, and step_p.

## operator[]() [2/2]

template<class T>

const T & casacore::ArrayBaseAccessor< T >::operator[] | ( | const int | ix | ) | const

inline

Index along current axis.

Definition at line 128 of file ArrayAccessor.h.

References ptr_p, and step_p.

## rbegin() [1/2]

template<class T>

const T * casacore::ArrayBaseAccessor< T >::rbegin | ( |  | ) |

inline

Begin when reverse indexing.

Definition at line 152 of file ArrayAccessor.h.

References end_p, and step_p.

## rbegin() [2/2]

template<class T>

const T * casacore::ArrayBaseAccessor< T >::rbegin | ( | const int | n | ) |

inline

Definition at line 153 of file ArrayAccessor.h.

References end_p, and step_p.

## rend() [1/2]

template<class T>

const T * casacore::ArrayBaseAccessor< T >::rend | ( |  | ) |

inline

End when reverse indexing.

Definition at line 146 of file ArrayAccessor.h.

References begin_p, and step_p.

## rend() [2/2]

template<class T>

const T * casacore::ArrayBaseAccessor< T >::rend | ( | const int | n | ) |

inline

Definition at line 147 of file ArrayAccessor.h.

References begin_p, and step_p.

## step()

template<class T>

size_t casacore::ArrayBaseAccessor< T >::step | ( |  | ) |

inline

Definition at line 123 of file ArrayAccessor.h.

References step_p.

## Member Data Documentation

## arrayPtr_p

template<class T>

const Array<T>* casacore::ArrayBaseAccessor< T >::arrayPtr_p

protected

The pointer to belonging array.

Definition at line 159 of file ArrayAccessor.h.

Referenced by ArrayBaseAccessor(), ArrayBaseAccessor(), ArrayBaseAccessor(), ArrayBaseAccessor(), ArrayBaseAccessor(), baseArray(), casacore::ArrayAccessor< T, Axis< U > >::index(), casacore::ArrayAccessor< T, Axis< U > >::index(), casacore::ArrayAccessor< T, Axis< U > >::index(), casacore::ArrayAccessor< T, Axis< U > >::index(), casacore::ArrayAccessor< T, AxisN >::index(), casacore::ArrayAccessor< T, AxisN >::index(), casacore::ArrayAccessor< T, AxisN >::index(), casacore::ArrayAccessor< T, AxisN >::index(), init(), init(), init(), casacore::ArrayAccessor< T, Axis< U > >::initOff(), casacore::ArrayAccessor< T, AxisN >::initOff(), casacore::ArrayAccessor< T, Axis< U > >::initStep(), casacore::ArrayAccessor< T, AxisN >::initStep(), casacore::ArrayAccessor< T, Axis< U > >::next(), casacore::ArrayAccessor< T, Axis< U > >::next(), casacore::ArrayAccessor< T, Axis< U > >::next(), casacore::ArrayAccessor< T, Axis< U > >::next(), casacore::ArrayAccessor< T, AxisN >::next(), casacore::ArrayAccessor< T, AxisN >::next(), casacore::ArrayAccessor< T, AxisN >::next(), casacore::ArrayAccessor< T, AxisN >::next(), operator=(), casacore::ArrayAccessor< T, Axis< U > >::prev(), casacore::ArrayAccessor< T, Axis< U > >::prev(), casacore::ArrayAccessor< T, Axis< U > >::prev(), casacore::ArrayAccessor< T, Axis< U > >::prev(), casacore::ArrayAccessor< T, AxisN >::prev(), casacore::ArrayAccessor< T, AxisN >::prev(), casacore::ArrayAccessor< T, AxisN >::prev(), and casacore::ArrayAccessor< T, AxisN >::prev().

## axis_p

template<class T>

size_t casacore::ArrayBaseAccessor< T >::axis_p

protected

Current run-time axis.

Definition at line 161 of file ArrayAccessor.h.

Referenced by casacore::ArrayAccessor< T, AxisN >::ArrayAccessor(), ArrayBaseAccessor(), ArrayBaseAccessor(), ArrayBaseAccessor(), ArrayBaseAccessor(), ArrayBaseAccessor(), init(), init(), casacore::ArrayAccessor< T, AxisN >::initOff(), and casacore::ArrayAccessor< T, AxisN >::initStep().

## begin_p

template<class T>

const T* casacore::ArrayBaseAccessor< T >::begin_p

protected

The start element of array.

Definition at line 167 of file ArrayAccessor.h.

Referenced by ArrayBaseAccessor(), ArrayBaseAccessor(), ArrayBaseAccessor(), ArrayBaseAccessor(), ArrayBaseAccessor(), begin(), begin(), casacore::ArrayAccessor< T, Axis< U > >::initStep(), casacore::ArrayAccessor< T, AxisN >::initStep(), casacore::ArrayAccessor< T, Axis< U > >::operator=(), rend(), rend(), casacore::ArrayAccessor< T, Axis< U > >::reset(), and casacore::ArrayAccessor< T, AxisN >::reset().

## end_p

template<class T>

const T* casacore::ArrayBaseAccessor< T >::end_p

protected

The one element beyond last on line.

Definition at line 169 of file ArrayAccessor.h.

Referenced by ArrayBaseAccessor(), ArrayBaseAccessor(), ArrayBaseAccessor(), ArrayBaseAccessor(), ArrayBaseAccessor(), end(), end(), casacore::ArrayAccessor< T, Axis< U > >::initStep(), casacore::ArrayAccessor< T, AxisN >::initStep(), casacore::ArrayAccessor< T, Axis< U > >::operator=(), rbegin(), and rbegin().

## ptr_p

template<class T>

T* casacore::ArrayBaseAccessor< T >::ptr_p

protected

Current access pointer.

Definition at line 163 of file ArrayAccessor.h.

Referenced by ArrayBaseAccessor(), ArrayBaseAccessor(), ArrayBaseAccessor(), ArrayBaseAccessor(), ArrayBaseAccessor(), data(), casacore::ArrayAccessor< T, Axis< U > >::index(), casacore::ArrayAccessor< T, Axis< U > >::index(), casacore::ArrayAccessor< T, Axis< U > >::index(), casacore::ArrayAccessor< T, Axis< U > >::index(), casacore::ArrayAccessor< T, AxisN >::index(), casacore::ArrayAccessor< T, AxisN >::index(), casacore::ArrayAccessor< T, AxisN >::index(), casacore::ArrayAccessor< T, AxisN >::index(), init(), init(), init(), casacore::ArrayAccessor< T, Axis< U > >::initStep(), casacore::ArrayAccessor< T, AxisN >::initStep(), casacore::ArrayAccessor< T, Axis< U > >::next(), casacore::ArrayAccessor< T, Axis< U > >::next(), casacore::ArrayAccessor< T, Axis< U > >::next(), casacore::ArrayAccessor< T, Axis< U > >::next(), casacore::ArrayAccessor< T, AxisN >::next(), casacore::ArrayAccessor< T, AxisN >::next(), casacore::ArrayAccessor< T, AxisN >::next(), casacore::ArrayAccessor< T, AxisN >::next(), casacore::ArrayAccessor< T, Axis< U > >::operator!=(), casacore::ArrayAccessor< T, Axis< U > >::operator!=(), casacore::ArrayAccessor< T, AxisN >::operator!=(), casacore::ArrayAccessor< T, AxisN >::operator!=(), operator*(), operator*(), operator++(), operator++(), operator+=(), operator--(), operator--(), operator-=(), operator=(), casacore::ArrayAccessor< T, Axis< U > >::operator==(), casacore::ArrayAccessor< T, Axis< U > >::operator==(), casacore::ArrayAccessor< T, AxisN >::operator==(), casacore::ArrayAccessor< T, AxisN >::operator==(), operator[](), operator[](), casacore::ArrayAccessor< T, Axis< U > >::prev(), casacore::ArrayAccessor< T, Axis< U > >::prev(), casacore::ArrayAccessor< T, Axis< U > >::prev(), casacore::ArrayAccessor< T, Axis< U > >::prev(), casacore::ArrayAccessor< T, AxisN >::prev(), casacore::ArrayAccessor< T, AxisN >::prev(), casacore::ArrayAccessor< T, AxisN >::prev(), casacore::ArrayAccessor< T, AxisN >::prev(), casacore::ArrayAccessor< T, Axis< U > >::reset(), casacore::ArrayAccessor< T, Axis< U > >::reset(), casacore::ArrayAccessor< T, AxisN >::reset(), and casacore::ArrayAccessor< T, AxisN >::reset().

## step_p

template<class T>

int casacore::ArrayBaseAccessor< T >::step_p

protected

The increment to go from one point along an axis, to the next.

Definition at line 165 of file ArrayAccessor.h.

Referenced by ArrayBaseAccessor(), ArrayBaseAccessor(), ArrayBaseAccessor(), ArrayBaseAccessor(), ArrayBaseAccessor(), begin(), end(), casacore::ArrayAccessor< T, Axis< U > >::initStep(), casacore::ArrayAccessor< T, AxisN >::initStep(), operator++(), operator++(), operator+=(), operator--(), operator--(), operator-=(), casacore::ArrayAccessor< T, Axis< U > >::operator=(), operator[](), operator[](), rbegin(), rbegin(), rend(), rend(), and step().

The documentation for this class was generated from the following file:

- casa/Arrays/ArrayAccessor.h